<template>
  <div class="container">
    <h2>Queue Page</h2>

    <template v-if="activeUserName">
      <h5>Welcome to Queue System, {{ activeUserName }}</h5>
      <h3 class="your-number">Your number: {{ activeQueueNumber }} </h3>

      <div class="btn-toolbar">
        <button class="btn btn-danger" @click="deQueue">Leave Queue</button>
      </div>
    </template>

    <queue-list :list="list"
                :active-user-name="activeUserName"/>
  </div>
</template>

<script>
  import APIHelper from '../api-helper'
  import QueueList from './QueueList.vue'

  export default {
    name: "QueuePage",
    components: {QueueList: QueueList},
    data() {
      return {
        list: []
      }
    },
    computed: {
      activeUserName() {
        const nm = this.$route.query.name;
        return nm ? decodeURIComponent(nm) : null;
      },
      activeQueueNumber() {
        const t = this.$route.query.n;
        return t ? decodeURIComponent(t) : null;
      }
    },
    methods: {
      deQueue() {
        if (this.activeUserName) {
          APIHelper.dequeue(this.activeUserName)
            .then(() => {
              this.$router.push('/registration');
            })
            .catch(err => {
              console.error(err);
              alert('Error leaving the queue');
            });
        }
      },
      refreshList() {
        APIHelper.getQueue()
          .then(list => {
            this.list = list;
          })
          .catch(err => {
            console.error(err);
            alert('There was an error getting the queue');
          });
      },
    },
    created() {
      this.refreshList();
    }
  }
</script>

<style scoped>
  .your-number {
    margin-top: 30px;
    margin-bottom: 15px;
  }
</style>